ENABLE_HOOK_VECTOR equ 81h

segment code

global get_int_vector
global set_int_vector

;retorna vector de interrupcion AL (offset;segmento) en el par de palabras 
;apuntado por ES:DI
get_int_vector:
        push ds
        push si
        push cx
        mov ah,0
        mov si,ax
        imul si,4
        cli
        xor ax,ax
        mov ds,ax
        mov cx,2
        cld
        rep movsw
        sti
        pop cx
        pop si
        pop ds 
        ret

;inicia vector de interrupcion AL (offset;segmento) con el par de palabras 
;apuntado por ES:BX
set_int_vector:
        push es
        push ds
        push di
        push cx
        push si
        mov ah,0
        mov di,ax
        imul di,4
        cli
        mov ax,es
        mov ds,ax
        xor ax,ax
        mov es,ax
        mov si,bx
        mov cx,2
        cld
        rep movsw
        sti
        pop si
        pop cx
        pop di
        pop ds 
        pop es
        ret


