CR equ 13
LF equ 10

segment code

global  print_int
global  print_short
global  print_char
global  print_string
global  print_nl
global  read_char
global  read_int
global  print_short_buffer

;*****************************

print_int:

        push    si
        push    dx
        push    cx
        mov     cx,4

print_int_lab1:
        rol     ax,4
        push    ax
        and     ax,000fh
        add     ax,TablaChars        
        
       mov     si,ax
       mov     dl,[si]

        push    cx
        mov     ah,2
        int     21h

        pop    cx
        pop    ax
        loop   print_int_lab1

        pop    cx
        pop    dx
        pop    si
        ret

;*****************************

print_short:

        push    si
        push    dx
        push    cx
        mov     cx,2

print_short_lab1:

        rol     al,4
        push    ax
        and     ax,000fh
        add     ax,TablaChars        
        
       mov     si,ax
       mov     dl,[si]

        push    cx
        mov     ah,2
        int     21h

        pop    cx
        pop    ax
        loop   print_short_lab1

        pop    cx
        pop    dx
        pop    si
        ret


;*****************************

%define LINEA_SIZE 24
                                                                                        
print_short_buffer:

        push    ax
        push    cx

print_short_buffer_lab1:

        mov     cx,LINEA_SIZE
        cmp     dx,cx
        ja      print_short_buffer_lab2        ;salta si size mayor que linea
        
        ;size_menor_linea     
        mov     cx,dx

print_short_buffer_lab2:

        sub     dx,cx
        push    dx

print_short_buffer_lab3:

        push    si
        push    cx
        mov     al,[si]
        call    print_short
        mov     al,' '
        call    print_char
        pop     cx
        pop     si
        inc     si
        loop    print_short_buffer_lab3
        call    print_nl
        pop     dx
        cmp     dx,0
        jne     print_short_buffer_lab1

        pop    cx
        pop    ax
        ret


;*****************************

print_char:

        push    dx

        mov     dl,al
        mov     ah,2
        int     21h                

        pop     dx
        ret

;*****************************

print_string:
        
        push    dx
        mov     dx,ax
        mov     si,ax
        dec     si

print_string_lab1:

        inc     si
        cmp     [si],BYTE 0
        jne     print_string_lab1                                      
        
        mov     [si],BYTE '$'
        
        push    si     

        mov ah,9
        int 21h   
     
        pop     si
        mov     [si],BYTE 0

        pop     dx
        ret    
        
;*****************************

print_nl:

      
        mov     dl,CR
        mov     ah,2
        int     21h

        mov     dl,LF
        mov     ah,2
        int     21h

        ret

;*****************************

read_char:

        mov     ah,8
        int     21h

        cmp     al,0
        je      read_char_lab1
        mov     ah,0
        ret                                 

read_char_lab1:

        mov     ah,8
        int     21h

        mov     ah,0
        ret          

;*****************************

read_int:

        mov     cx,0

read_int_lab1:

        mov     ah,1
        int     21h
      
        cmp     al,0
        je      read_int_lab2
        
        cmp     al,'0'
        jl      read_int_end
                
        cmp     al,'9'
        jg      read_int_end       
        
        imul    cx,10
        mov     ah,0
        sub     al,'0'
        add     cx,ax
        jmp     read_int_lab1

read_int_end
        
        mov     ax,cx
        push    ax
        call print_nl
        pop     ax
        ret

read_int_lab2:
                                  
        mov     ah,1
        int     21h

        call    print_nl
        mov     ax,0
        ret          
        

TablaChars              DB      '0','1','2','3','4','5','6','7','8','9','A','B','C','D','E','F'

