;************** DECLARACIONES **********************************

extern print_int
; imprime el valor entero en AX a la pantalla

extern print_nl
; imprime caracter de fin de linea a la pantalla

extern print_char
; imprime el caracter en AL a la pantalla

extern print_string
; imprime el contenido de un string apuntado por AX a la pantalla.
; Se trata de un string tipo C, esto es, terminado en caracter nulo

extern read_char
; lee un unico caracter desde el teclado y lo devuelve en AX

extern read_int
; lee un numero entero desde el teclado y lo devuelve en AX

;********** MACROS DEFINE **********************************

%define CR 13
%define LF 10

;***************************** MACROS ********************

%macro PRINT_STRING_MACRO 0
        
        push    dx
        mov     dx,ax
        mov     si,ax
        dec     si

%%lab1:

        inc     si
        cmp     [si],BYTE 0
        jne     %%lab1                  
        
        mov     [si],BYTE '$'
        
        push    si     

        mov ah,9
        int 21h   
     
        pop     si
        mov     [si],BYTE 0

        pop     dx    

%endmacro
        
%macro PRINT_NL_MACRO 0
     
        mov     dl,13
        mov     ah,2
        int     21h

        mov     dl,10
        mov     ah,2
        int     21h

%endmacro

%macro PRINT_INT_MACRO 0
        
        jmp     %%lab0

%%labTabla              DB      '0','1','2','3','4','5','6','7','8','9','A','B','C','D','E','F'

%%lab0:
        push    si
        push    dx
        push    cx
        mov     cx,4

%%lab1:
        rol     ax,4
        push    ax
        and     ax,000fh
        add     ax,%%labTabla
        
       mov     si,ax
       mov     dl,[si]

        push    cx
        mov     ah,2
        int     21h

        pop    cx
        pop    ax
        loop   %%lab1

        pop    cx
        pop    dx
        pop    si

%endmacro


;*****************************

